import subprocess
import sys, re

def get_cameras():                                           # get list of available cameras  
    vd = []
    stat, ls = commands.getstatusoutput( 'ls -l /dev/v4l/by-id' )
    if stat != 0: return vd
    for dir in ls.splitlines():
        i = dir.find( 'index' )
        if i < 0: continue 
        vv = dir[ i: ].split( ' -> ' )
        if int( vv[ 0 ][ ( re.search( '\d', vv[ 0 ] ).start( 0 ) ): ] ) != 0:
            continue                                               # video index not 0
        vd.append( int( vv[ 1 ][ ( re.search( '\d', vv[ 1 ] ).start( 0 ) ): ] ) )
    return vd


def get_cameras():                                           # get list of available cameras  
    vd = []
    proc = subprocess.Popen( [ 'ls', '-l', '/dev/v4l/by-id' ],
                             stdout=subprocess.PIPE, stderr=subprocess.PIPE )
    stat = proc.wait()
    if stat != 0: return vd                                  # no available video cameras    
#    print( 'no video cameras!' )
#    sys.exit( 0 )
    z = proc.stdout.read().decode( "utf-8" ).splitlines()
    for s in z:
        i = s.find( 'index' )
        if i < 0: continue                                     # not a video line                      
        vv = s[ i: ].split( ' -> ' )
#        print( vv )
        if int( vv[ 0 ][ ( re.search( '\d', vv[ 0 ] ).start( 0 ) ): ] ) != 0:
            continue                                              # index not 0
#    print( vv[ 0 ].strip(), ' | ', vv[ 1 ].strip( ' ./' ) )
        vd.append( int( vv[ 1 ][ ( re.search( '\d', vv[ 1 ] ).start( 0 ) ): ] ) )
#print( 'cameras: {}'.format( vd ) )
    return vd

def get_default():                                             # get index of the default camera
    vd = get_cameras()
    if len( vd ) != 0: return vd[ 0 ]
    else: return -1
